## tinyxml2 10.0.0+dfsg

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(tinyxml2-test)

enable_testing()

find_package(tinyxml2 REQUIRED)

add_executable(xmltest ../xmltest.cpp)
target_link_libraries(xmltest PRIVATE tinyxml2::tinyxml2)

add_test(
    NAME xmltest
    COMMAND xmltest
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/.."
)

set_tests_properties(xmltest
                     PROPERTIES
                     PASS_REGULAR_EXPRESSION ", Fail 0"
                     ENVIRONMENT "PATH=$<TARGET_FILE_DIR:tinyxml2::tinyxml2>")

=== debian/changelog ===
tinyxml2 (10.0.0+dfsg-2) unstable; urgency=medium

  [ Jenkins ]
  * [c0b0d65] Set upstream metadata fields: Bug-Database, Bug-Submit,
    Repository, Repository-Browse.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-file-is-missing
    Fixes: lintian: upstream-metadata-missing-bug-tracking
    Fixes: lintian: upstream-metadata-missing-repository
  * [089faba] Remove Section on libtinyxml2-9 that duplicates source.
    Changes-By: lintian-brush
    Fixes: lintian: binary-control-field-duplicates-source

  [ Debian Janitor ]
  * [5c99140] Use secure URI in Homepage field.
    Changes-By: lintian-brush
    Fixes: lintian: homepage-field-uses-insecure-uri
  * [f16bddf] Bump debhelper from old 12 to 13.
    Changes-By: lintian-brush
    Fixes: lintian: package-uses-old-debhelper-compat-version
  * [b8747ae] Remove constraints unnecessary since buster (oldstable)
    * Build-Depends: Drop versioned constraint on dpkg-dev.
    Changes-By: deb-scrub-obsolete

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 05 Jan 2024 23:29:38 +0800

tinyxml2 (10.0.0+dfsg-1) unstable; urgency=medium

  * [31b2418] New upstream version 10.0.0+dfsg
  * [b38f32c] Refresh patches
  * [d00e929] Rename binary package for soname bump
  * [70c9b49] Update symbols file

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 05 Jan 2024 23:29:34 +0800

tinyxml2 (9.0.0+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Install cmake files (Closes: #967045)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 16 May 2022 11:14:34 +0200

tinyxml2 (9.0.0+dfsg-3) unstable; urgency=medium

  * [a6e98f0] Drop Provides/Conflicts libtinyxml2-8 (Closes: #992602)

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 21 Aug 2021 22:50:44 +0800

tinyxml2 (9.0.0+dfsg-2) unstable; urgency=medium

  * Reupload to unstable

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 20 Aug 2021 19:22:15 +0800

tinyxml2 (9.0.0+dfsg-1) experimental; urgency=medium

  * [1915c59] New upstream version 9.0.0+dfsg
  * [7afaa6f] Update package name and symbols file for soname bump

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 08 Jun 2021 01:24:52 +0800

tinyxml2 (8.1.0+really8.1.0+dfsg-1) experimental; urgency=medium

  * [565d5af] New upstream version 8.1.0+really8.1.0+dfsg
  * [5efb233] Revert debian/* to the state at 8.1.0+dfsg-2
  * [43398c1] Amend version for the new symbol introduced in 8.1.0.
    Since 8.1.0 now precedes 8.1.0+really8.0.0, we need to bump this version to
    get proper versioning.

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 05 Jun 2021 17:25:41 +0800

tinyxml2 (8.1.0+dfsg-2) experimental; urgency=medium

  * [0c13ef0] Rename package for abi break (Closes: #988986)

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 01 Jun 2021 16:01:13 +0800

=== debian/watch ===
version=3

opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/tinyxml2-$1.tar.gz/,dversionmangle=s/\+dfsg(\.\d+)?$//,repacksuffix=+dfsg" \
https://github.com/leethomason/tinyxml2/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz

## tinyxml2 10.1.0+dfsg

=== debian/changelog ===
tinyxml2 (10.1.0+dfsg-1) unstable; urgency=medium

  * [e3fe268] New upstream version 10.1.0+dfsg
    - Fixes CVE-2024-50615 (Closes: #1088814)
  * [4b330c9] Refresh patches
  * [870daa6] Update watch file to version 4 and use example from uscan manpage

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 14 Mar 2025 12:49:48 +0800

## tinyxml2 11.0.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(tinyxml2 VERSION 11.0.0)

include(CTest)
option(tinyxml2_BUILD_TESTING "Build tests for tinyxml2" "${BUILD_TESTING}")

##
## Honor tinyxml2_SHARED_LIBS to match install interface
##

if (DEFINED tinyxml2_SHARED_LIBS)
    set(BUILD_SHARED_LIBS "${tinyxml2_SHARED_LIBS}")
endif ()

##
## Main library build
##

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN YES)

add_library(tinyxml2 tinyxml2.cpp tinyxml2.h)
add_library(tinyxml2::tinyxml2 ALIAS tinyxml2)

# Uncomment the following line to require C++11 (or greater) to use tinyxml2
# target_compile_features(tinyxml2 PUBLIC cxx_std_11)
target_include_directories(tinyxml2 PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")

target_compile_definitions(
    tinyxml2
    PUBLIC $<$<CONFIG:Debug>:TINYXML2_DEBUG>
    INTERFACE $<$<BOOL:${BUILD_SHARED_LIBS}>:TINYXML2_IMPORT>
    PRIVATE $<$<CXX_COMPILER_ID:MSVC>:_CRT_SECURE_NO_WARNINGS>
    PUBLIC _FILE_OFFSET_BITS=64
)

set_target_properties(
    tinyxml2
    PROPERTIES
    DEFINE_SYMBOL "TINYXML2_EXPORT"
    VERSION "${tinyxml2_VERSION}"
    SOVERSION "${tinyxml2_VERSION_MAJOR}"
)

if (tinyxml2_BUILD_TESTING)
    add_executable(xmltest xmltest.cpp)
    target_link_libraries(xmltest PRIVATE tinyxml2::tinyxml2)

    add_test(
        NAME xmltest
        COMMAND xmltest
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    )

    set_tests_properties(xmltest PROPERTIES PASS_REGULAR_EXPRESSION ", Fail 0")
endif ()

##
## Installation
##

## Standard modules
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

## Custom settings
option(tinyxml2_INSTALL_PKGCONFIG "Create and install pkgconfig files" ON)

set(tinyxml2_INSTALL_PKGCONFIGDIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
    CACHE PATH "Directory for pkgconfig files")

set(tinyxml2_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/tinyxml2"
    CACHE STRING "Path to tinyxml2 CMake files")

## CMake targets and export scripts

install(
    TARGETS tinyxml2 EXPORT tinyxml2-targets
    RUNTIME COMPONENT tinyxml2_runtime
    LIBRARY COMPONENT tinyxml2_runtime
    NAMELINK_COMPONENT tinyxml2_development
    ARCHIVE COMPONENT tinyxml2_development
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

# Type-specific targets

if (BUILD_SHARED_LIBS)
    set(type shared)
else ()
    set(type static)
endif ()

install(
    EXPORT tinyxml2-targets
    DESTINATION "${tinyxml2_INSTALL_CMAKEDIR}"
    NAMESPACE tinyxml2::
    FILE tinyxml2-${type}-targets.cmake
    COMPONENT tinyxml2_development
)

# Auto-generated version compatibility file
write_basic_package_version_file(
    tinyxml2-config-version.cmake
    COMPATIBILITY SameMajorVersion
)

install(
    FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/tinyxml2-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/tinyxml2-config-version.cmake"
    DESTINATION "${tinyxml2_INSTALL_CMAKEDIR}"
    COMPONENT tinyxml2_development
)

## Headers

install(
    FILES tinyxml2.h
    TYPE INCLUDE
    COMPONENT tinyxml2_development
)

## pkg-config

if (tinyxml2_INSTALL_PKGCONFIG)
    configure_file(cmake/tinyxml2.pc.in tinyxml2.pc.gen @ONLY)
    file(GENERATE OUTPUT tinyxml2.pc INPUT "${CMAKE_CURRENT_BINARY_DIR}/tinyxml2.pc.gen")
    install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/tinyxml2.pc"
        DESTINATION "${tinyxml2_INSTALL_PKGCONFIGDIR}"
        COMPONENT tinyxml2_development
    )
endif ()

=== debian/changelog ===
tinyxml2 (11.0.0+dfsg-1) unstable; urgency=medium

  * [cb69d19] New upstream version 11.0.0+dfsg
  * [b97c731] Rename package for soname bump

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 17 Mar 2025 15:44:04 +0800

=== debian/control ===
Source: tinyxml2
Priority: optional
Maintainer: Chow Loong Jin <hyperair@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake
Build-Conflicts: libssl1.0.0 (= 1.0.2-1)
Standards-Version: 4.1.3
Section: libs
Homepage: https://www.grinninglizard.com/tinyxml2/
Vcs-Browser: https://salsa.debian.org/debian/tinyxml2
Vcs-Git: https://salsa.debian.org/debian/tinyxml2.git

Package: libtinyxml2-dev
Section: libdevel
Architecture: any
Depends: libtinyxml2-11 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: TinyXML2 library - header and static library
 This package contains the header file and a static version of the
 TinyXML2 library.
 .
 TinyXML2 is a simple and small C++ XML parser that can be easily integrating
 into other programs. It reads XML and creates C++ objects representing the XML
 document. The objects can be manipulated, changed, and saved again as XML.
 .
 TinyXML2 supersedes the previous TinyXML library, with various improvements:
  - Fewer memory allocations (1% - 10% compared to TinyXML)
  - Uses less memory (about 40% of that used by TinyXML)
  - Faster
  - No STL requirement
  - More modern C++, including a proper namespace
  - Proper and useful handling of whitespace

Package: libtinyxml2-11
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: C++ XML parsing library
 This package contains the shared version of the TinyXML2 library.
 .
 TinyXML2 is a simple and small C++ XML parser that can be easily integrating
 into other programs. It reads XML and creates C++ objects representing the XML
 document. The objects can be manipulated, changed, and saved again as XML.
 .
 TinyXML2 supersedes the previous TinyXML library, with various improvements:
  - Fewer memory allocations (1% - 10% compared to TinyXML)
  - Uses less memory (about 40% of that used by TinyXML)
  - Faster
  - No STL requirement
  - More modern C++, including a proper namespace
  - Proper and useful handling of whitespace

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

override_dh_auto_configure:
	dh_auto_configure -Bbuild -Scmake --			      \
		-DCMAKE_INSTALL_LIBDIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
		-DBUILD_SHARED_LIBS=yes

override_dh_auto_clean:
	rm -rf build

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

%:
	dh $@ -Bbuild -Scmake

=== debian/watch ===
version=4

opts=\
    filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
    downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
    dversionmangle=s/\+dfsg(\.\d+)?$//,\
    repacksuffix=+dfsg,\
    searchmode=plain \
    https://api.github.com/repos/leethomason/tinyxml2/git/matching-refs/tags/ \
    https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
